#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <stdlib.h>

#define IP_DEF "127.0.0.1"
#define PORT_DEF 2010
#define BUF_SIZE 256

int main(int argc, char *argv[]){

	int port;
	char *ip_addr;
	if (argc == 1){
		port = PORT_DEF;
    	ip_addr = IP_DEF;
  	} else if (argc == 2){
  		port = atoi(argv[1]);
  		ip_addr = IP_DEF;
  	} else if (argc == 3){
  		struct hostent *tmp;
		if ((tmp = gethostbyname(argv[1])) == NULL){	
     		herror("gethostbyname"); 
		}else{
			ip_addr = inet_ntoa(*((struct in_addr *)tmp->h_addr));
		}
    	port = atoi(argv[2]);
  	} else {
		printf ("Przykladowe uzycie:\n");
		printf ("   ./klient  - uruchomienie klienta z domyslnymi ustawieniami\n");
		printf ("   ./klient NR_PORTU \n");
 		printf ("   ./klient IP_SERWERA NR_PORTU\n");
		exit(1);
	}
	int sock_desc;
	struct sockaddr_in my_addr;
	if ((sock_desc = socket(AF_INET, SOCK_STREAM,0)) == -1){
		perror("socket");
		exit(1);
	}
	my_addr.sin_family = AF_INET;
	my_addr.sin_port = htons(port);
	my_addr.sin_addr.s_addr = inet_addr(ip_addr);
	memset(&(my_addr.sin_zero), '\0', 8);
	if (connect(sock_desc, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1){
    	perror("connect");
    	exit(1);
    }
	int a,b;
	int c=1;
	printf ("Podaj dwie liczbty całkowite by otrzymac odwrocony lancuch kolejnych liczb od B do A\n");
	fflush(stdin);
	printf ("Wprowadz A:");
	if (scanf("%d",&a)!=1){
		printf("liczba A nie jest liczba calkowita. Blad!\n");
		exit(1);
	}
	printf ("Wprowadz B:");
	if (scanf("%d",&b)!=1){
		printf("liczba B nie jest liczba calkowita. Blad!\n");
		exit(1);
   	}
   	send(sock_desc, &a, sizeof(int), 0);
	send(sock_desc, &b, sizeof(int), 0);
	recv(sock_desc, &a, sizeof(int), 0);
	if(c){
		while ( a!=777777){
			printf ("%d, ", a);
    		recv(sock_desc, &a, sizeof(int), 0);
    		c=0;
    	}
	}
	printf ("\n");
    close(sock_desc);
    return 0;
}
